//Plugin data holder
var ProtoEntry = function(){
    this.eId =  "";
    this.Title = "";
    this.order = 0;
    this.Action = "";
    this.Method = "";
    this.referrer = "";
    this.opentarget = "";
    this.Desc =  "";
    //this.Inputs = new Object;
    this.Context = true;
    this.blocked = false;
    this.filepath = "";
    this.iconpath = "";
    this.qcharset = "UTF-8";
    this.showif = "";
    this.sitarget = "[:selection]";
    this.si_compiled = new Object;
    this.lastmatch = [];

    this._Clone = function(){
        var NewObj = new Object();
        for (var oP in this) NewObj[oP]=this[oP];
        return NewObj;
    }
  
    this._StoreInput = function(inp){
        lst = new Object();
        inobj = new Object();
        inobj.name = String(inp.name);
        inobj.value = String(inp.value);
        if (inp.label) {inobj.label=inp.label} else {inobj.label=""};
        if (inp.grouptitle) {inobj.grouptitle=inp.grouptitle} else {inobj.grouptitle=""};
        inobj.priority = String(inp.priority);
        ItemName = inp.name;
        //ItemName = String(inp.priority);
  	
  	if (this.Inputs!=null){
  		if (this.Inputs[ItemName]){
  			if (!this.Inputs[ItemName].list){
  			  this.Inputs[ItemName].list = new Object();
  			  this.Inputs[ItemName].list[this.Inputs[ItemName].def.priority] = this.Inputs[ItemName].def;
  			}
  			this.Inputs[ItemName].list[inp.priority] = inobj;
  		}else{
  			this.Inputs[ItemName] = new Object();
  			this.Inputs[ItemName] = inobj;
  			this.Inputs[ItemName].def = new Object();
  			this.Inputs[ItemName].def = inobj;
  			//this.Inputs[ItemName].list = new Object();
  			//this.Inputs[ItemName].list[inp.priority] = inobj;
  		}
  	}else{
  		this.Inputs = new Object();
  		this.Inputs[ItemName] = new Object();
          this.Inputs[ItemName] = inobj;
  		this.Inputs[ItemName].def = new Object();
  		this.Inputs[ItemName].def = inobj;
  	}
  }
}

//Entries holder:
var _ProtoHash = function(){
    this.Items = [];
    this.orderIndex = [];
    this.orderIndex[0] = "reserved for plugins status detection";
    this.sorted = false;
    
    this._AddEntryObj = function (EntryObj, eId){
        //eId = String(EntryObj.filepath).replace(/[\\\/\.:]/ig, "");
        tmp = EntryObj.filepath.split(cqrdelim);
        eId = tmp[tmp.length-1].replace(/\./ig, "-");
        EntryObj.eId = eId;
        this.Items[eId] = EntryObj._Clone();
        prfs_UpdateEntryPrefs(eId);
        this.orderIt(eId);
        prfs_SaveEntry(this.Items[eId]);
        this._Empty = false;
        return eId;
    }
  
    this.orderIt = function(id){
        var itemOrder = parseFloat(this.Items[id].order);
        var itemId = this.Items[id].eId;
    //dump("Incoming plug: " + itemId + " with order=" + itemOrder + "\n");
        if (itemOrder < 1) {
            movedTo = this.orderIndex.length;
            this.orderIndex[movedTo] = itemId;
            this.Items[itemId].order = movedTo;
            //dump(">>> New SP " + itemId + " landed at index: " + movedTo + "\n");
            return;
        }
        if (this.orderIndex[itemOrder] && this.orderIndex[itemOrder] != itemId){
            occupantId = this.orderIndex[itemOrder];
            movedTo = this.orderIndex.length;
            this.Items[occupantId].order = movedTo;
            this.orderIndex[movedTo] = occupantId;
            prfs_SaveEntry(this.Items[occupantId]);
            this.orderIndex[itemOrder] = itemId;
            //dump(">>> Found occupant: " + occupantId + " at index: " + itemOrder + "\n");
            //dump(">>> " + occupantId + " moved to: " + this.Items[occupantId].order + " owner landed: " + itemId + "\n");

        } else {
            this.orderIndex[itemOrder] = itemId;
            //dump(">>> owner " + itemId + " landed at index: " + itemOrder + "\n");
        }
    }
  
    this._UpdateEntry = function(EntryObj){
        for (each in EntryObj){
            if (each != "Inputs") this.Items[each]=EntryObj[each]
        }
    }
  
    this._Exist = function (KeyName){
        var exst=false;
        if (this.Items[KeyName]) exst=true; 
        return exst;
    }
  
    this._Item = function (KeyName){
        return this.Items[KeyName];
    }
  
    this.rm = function(Key){
        delete this.Items[Key];
    }
  
    this.sort = function(){
        var items = [];
        var tmpArr = [];
        for (each in this.Items) tmpArr.push(this.Items[each]);
        tmpArr.sort(this._Cmp);
        this.clear();
        for (i=0; i<tmpArr.length;i++) this.Items[tmpArr[i].eId] = tmpArr[i];
        this.sorted = true;
    }

    this._Items = function(){
        return this.Items;
    }

    this.mainSet = function(limit){
        var retItems = [];
        if (limit == 0) return retItems;
        var i=0;
        for (each in this.Items){
            if (i >= limit) break;
            if (this.Items[each].Context == true && this.Items[each].blocked == false){
                retItems[each] = this.Items[each];
                i++;
            }
        }
        return retItems;
    }

    this.conquerySet = function(limit){
        var retItems = [];
        var i=0;
        for (each in this.Items){
            if (this.Items[each].Context == true && this.Items[each].blocked == false){
                if (i >= limit) retItems[each] = this.Items[each];
                i++;
            }
        }
        return retItems;
    }

    this.showifSet = function(){
        var retItems = [];
        for (each in this.Items){
            if (this.Items[each].showif && this.Items[each].Context == false && this.Items[each].blocked == false){
                retItems[each] = this.Items[each];
            }
        }
        return retItems;
    }

    this._Cmp = function(a, b){
        return a.order - b.order;
    }

    this.clear = function(){
        this.Items = [];
        this.orderIndex[0] = "reserved for plugins status detection";
        this._Empty = true;
    }
}

 /////// END classes ////////
////////////////////////////


 ////////////////////////////
//////// Globals ///////////

//Active Entries holder
var EntryHash = new _ProtoHash();

var QueryHash = new Object();
var curDirState = new Object();
var lastDirState = new Object();
var cqrShowAlternatives = false;
var cqrcancel = false;

var cqrParamsRE = new RegExp('\\w+\\s*?=\\s*?".*?"',"ig");
var cqrSIRe = new RegExp("\\[:(\\w+)(:(\\d*))?\\]", "ig");

if (navigator.userAgent.search(/Thunderbird/gi) != -1){
    var cqrMailFlag = true;
} else {
    var cqrMailFlag = false;
}

var cqr_platform = new String(navigator.platform);
if(cqr_platform.search(/^Win/)) {
    if(cqr_platform.search(/^Mac/)) {
        var cqrdelim = "/";
    } else {
        var cqrdelim = ":";
    }
} else {
    var cqrdelim = "\\";
}
var cqrMess = srGetStrBundle("chrome://conquery/locale/conquery.properties");

/// Prefs globals ///
var cqrPrefs = Components.classes["@mozilla.org/preferences-service;1"].
  getService(Components.interfaces.nsIPrefService).getBranch("conquery.");
var cqrPlugsDir = "";
var cqrUseHotMenu = false;
var cqrHTTPIcon = true;
var cqrOpenRes = "";
var cqrHideFromTools = false;
var cqrShowCSPInMainMenu = false;
var cqrHideQueryTo = false;
var cqrMainContextLimit = 3;
prfs_LoadMain();

function cqerr(r, msg){
  //alert (cqrMess.GetStringFromName("cqr.err.failed")+msg+"\n"+r);
  dump("ConQuery >>> failed:" + msg + "\n"+r+"\n");
}

function plg_QuickLoadAll(){
    EntryHash.clear();
    lastDirState = rdir(cqrPlugsDir);
    //for (each in lastDirState) EntryHash._AddEntryObj(plg_quickread(each), "");
    for (each in lastDirState) EntryHash._AddEntryObj(plg_ReadData(each, true), "");
    EntryHash.sort();
}

function plg_ReadData(filepath, omit_inputs){
    var retItem = new ProtoEntry();
	filedata = cqReadFile(filepath);
	filedata = filedata.replace(/^\s*#.*/ig,"");
	filedata = filedata.replace(/[\n\r\f\t]/ig,"  ");
	SearchTagData = filedata.match(/<search.+?<\/search>/gi);
	mcSearch = plg_GetTags("search", SearchTagData);
	//mcSearch = plg_GetTags("search", filedata);
	if (mcSearch[0]){
		retItem.Title = mcSearch[0].name || cqrMess.GetStringFromName('cqr.err.parse');
		retItem.Action = mcSearch[0].action || "http://conquery.mozdev.org/pluginsdocs.html";
		retItem.Desc = mcSearch[0].description || "";
        retItem.referrer = mcSearch[0].referrer || "";
        retItem.opentarget = mcSearch[0].opentarget || "";
		//XXX: Leo's malformed plugins special patch:
		    p_plgname = filepath.split(cqrdelim);
		    if (p_plgname[p_plgname.length-1] == "leo.src") {
	            //because of two "name" params defined:
	            retItem.Title = "Leo Eng<->Ger";
	            //because of malformed action:
	            retItem.Action = "http://dict.leo.org/";
	            retItem.Desc = cqrMess.GetStringFromName('cqr.err.leo') + retItem.Desc;
		    } else if (p_plgname[p_plgname.length-1] == "leofrn.src"){
	            //because of two name params defined:
	            retItem.Title = "Leo Frn<->Amd";
	            //because of malformed action:
	            retItem.Action = "http://dico.leo.org/";
	            retItem.Desc = cqrMess.GetStringFromName('cqr.err.leo') + retItem.Desc;
		    }
		//EOf leo patch
		retItem.Method = mcSearch[0].method || "GET";
		retItem.qcharset = mcSearch[0].querycharset || "UTF-8";
		retItem.showif = mcSearch[0].showif || ""; 
		if (retItem.showif) {
		    re = new RegExp(retItem.showif, "ig");
		    retItem.si_compiled = re;
		}
		retItem.sitarget = mcSearch[0].showiftarget || "[:selection]";
		if (!omit_inputs) {
            var inp = plg_GetTags("input", SearchTagData);
            for (each in inp) retItem._StoreInput(inp[each]);
        }
        retItem.eId = "";
		retItem.filepath = filepath;
		retItem.iconpath = getPlugIcon(filepath);
		retItem.Context = true;
	}else{
	  	retItem.eId = "";
	  	retItem.Title = cqrMess.GetStringFromName('cqr.err.parse');
	  	retItem.Method = "GET";
	  	retItem.Desc = filepath;
	  	retItem.Context = false;
	  	retItem.FilePath = filepath;
	}
    return retItem;	
}

function plg_GetTags(tag, str){
	//This extracts all <tag param="val< - > ue"> patterns from str
	var TagsData = [];
	var TagsBuff = [];
	var cqrTagsRE = new RegExp('<'+tag+'\\s.+?>(?=[^"<]+?<|$)', "ig");
	while (TagsBuff!=null){
        TagsBuff = cqrTagsRE.exec(str);
        if (TagsBuff!=null){
            TagsData[TagsData.length]=plg_TagParams(TagsBuff[0]);
            TagsData[TagsData.length-1].priority = cqrTagsRE.lastIndex;
        }
	}
return TagsData;
}

function plg_TagParams(tag){
  var Params = new Object;
  var ParamsBuff = "  ";
  var ParamsData = [];
  //To correct Mycroft's "user" in <input>.
  tag = String(tag).replace(/\s+?user(="")*(?=\s*[\/>])/i, ' value="[:selection]"');
  Params["value"]= cqrMess.GetStringFromName('cqr.err.parse');
  ParamsBuff = cqrParamsRE.exec(tag);
  while (ParamsBuff!=null){
		if (ParamsBuff!=null){
			ParamsArr = String(ParamsBuff[0]).split(/=\s*"/);
			ParamsArr[1] = ParamsArr[1].replace(/^\s+/, "");
			Params[String(ParamsArr[0].replace(/\s+/,"")).toLowerCase()] = ParamsArr[1].replace(/"\s*/, "");
			ParamsBuff = cqrParamsRE.exec(tag);
		}
	}
return Params;
}

function rdir(dirname){
try{
  var arr = [];
  var dir = Components.classes["@mozilla.org/file/local;1"].
             createInstance(Components.interfaces.nsILocalFile);
  dir.initWithPath(dirname);
  if (dir.isDirectory()) {
      items = dir.directoryEntries;
  } else {
      cqerr("", "Error reading directory:\n" + dirname);
      return arr;
  }

  items.QueryInterface(Components.interfaces.nsISimpleEnumerator);
  while (items.hasMoreElements()) {
    var i = items.getNext();
    i.QueryInterface(Components.interfaces.nsIFile);
    if (!i.isDirectory()){
      var fn = i.leafName;
      var fx = fn.substr(fn.length - 4, fn.length).toLowerCase();
      if ((fx == ".cqr")||(fx == ".src")) arr[i.path] = i.lastModifiedTime;
    }
  }
return arr;
}catch(err){return arr}
}

function cqReadFile(filename) {
    var MODE_RDONLY = 0x01;
    var PERM_IRUSR = 00400;
    
    try {
        var file = Components.classes["@mozilla.org/file/local;1"].
                   createInstance(Components.interfaces.nsILocalFile);
        file.initWithPath(filename);
        if (file.exists() && file.isReadable()) {
            var is = Components.classes["@mozilla.org/network/file-input-stream;1"].
                     createInstance(Components.interfaces.nsIFileInputStream);
            is.init(file, MODE_RDONLY, PERM_IRUSR, 0);
            var sis = Components.classes["@mozilla.org/scriptableinputstream;1"].
                createInstance(Components.interfaces.nsIScriptableInputStream);
            sis.init(is);
            var data = sis.read(sis.available());
            sis.close();
            is.close();
            //return data;
            //thanks to Kuang-che Wu for UTF patch, found here:
            //http://www.csie.ntu.edu.tw/~r92030/project/patches.html
            try{
                var uc = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].
                createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
                uc.charset = "UTF-8";
                return uc.ConvertToUnicode(data);
            }catch(er){
                return data;
            }
        }
        else {
            cqerr(null, "File " + filename + " read error in cqReadFile\n");
            return null;
        }
    }
    catch (er) {
        cqerr(er, "File" + filename + "read error in cqReadFile\n");
    }
    return null;
}

function GetMycroftDir(){
	var gDirServiceProp = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
	var gChromeDir      = gDirServiceProp.get("AChrom",Components.interfaces.nsIFile);
	patharr = gChromeDir.path.split(cqrdelim);
	patharr[patharr.length-1]="searchplugins";
	return patharr.join(cqrdelim);
}

function srcDirChanged() {
  var rval = false;
  var lastcnt = 0;
  var curcnt = 0;
  
  for (each in lastDirState) { lastcnt+=1 }
  for (each in curDirState) { curcnt+=1 }

  if (lastcnt != curcnt) {
    rval = true;
  } else {
    for (each in lastDirState) {
      if (curDirState[each] != lastDirState[each]) { 
        rval = true;
        break;
      }
    }
  }
  curDirState = lastDirState;
  //rval = true;
  return rval;
}

function prfs_LoadMain(){
  cqrPlugsDir = prfs_ReadItem("Main.PlugsDir");
  cqrUseHotMenu = prfs_ReadItem("Main.UseHotMenu");
  cqrHTTPIcon = prfs_ReadItem("Main.HTTPIcon");
  cqrOpenRes = prfs_ReadItem("Main.OpenResults");
  cqrHideFromTools = prfs_ReadItem("Main.HideFromTools")||false;
  cqrShowCSPInMainMenu = prfs_ReadItem("Main.ShowCSPInMainMenu")||false;
  cqrHideQueryTo = prfs_ReadItem("Main.cqrHideQueryTo")||false;
  cqrMainContextLimit = prfs_ReadItem("Main.MainContextLimit")||0;
  
  if (!cqrPlugsDir) cqrPlugsDir = GetMycroftDir();
  if (cqrOpenRes == "") {cqrOpenRes = "tab_bg"};
}

function prfs_SaveMain(){
    cqrPlugsDir = document.getElementById("prfs_plugsdir").value;
    cqrUseHotMenu = document.getElementById("enhotmenu").checked;
    cqrHTTPIcon = document.getElementById("HTTPIcon").checked;
    cqrOpenRes = document.getElementById("open_res").selectedItem.id;
    cqrHideFromTools = document.getElementById('hidefromtools').checked;
    cqrShowCSPInMainMenu = document.getElementById('cspInMainMenu').checked;
    cqrHideQueryTo = document.getElementById('cqrHideQueryTo').checked;
    cqrMainContextLimit = document.getElementById('MainContextLimit').value;
  
    cqrPrefs.setCharPref("Main.PlugsDir", cqrPlugsDir);
    cqrPrefs.setBoolPref("Main.UseHotMenu", cqrUseHotMenu);
    cqrPrefs.setBoolPref("Main.HTTPIcon", cqrHTTPIcon);
    cqrPrefs.setCharPref("Main.OpenResults", cqrOpenRes);
    cqrPrefs.setBoolPref("Main.HideFromTools", cqrHideFromTools);
    cqrPrefs.setBoolPref("Main.ShowCSPInMainMenu", cqrShowCSPInMainMenu);
    cqrPrefs.setBoolPref("Main.cqrHideQueryTo", cqrHideQueryTo);
    cqrPrefs.setIntPref("Main.MainContextLimit", cqrMainContextLimit);
    prfs_SaveEntries();
}

function prfs_UpdateEntries(){
  for (each in EntryHash.Items) prfs_UpdateEntryPrefs(each);
  EntryHash.sort();
}

function prfs_UpdateEntryPrefs(id){
  if (EntryHash.Items[id]){
    EntryHash.Items[id].blocked = prfs_ReadItem("Entries."+id+".blocked");
    var cntx = new Boolean;
    cntx = prfs_ReadItem("Entries."+id+".Context");
    if (String(cntx) != ""){
      EntryHash.Items[id].Context = cntx;
    }else{
      EntryHash.Items[id].Context = true;
    }
    EntryHash.Items[id].order = prfs_ReadItem("Entries."+id+".Order")||0;
  }
}

function prfs_SaveEntries(){
  cqrPrefs.deleteBranch("Entries.");
  for (e in EntryHash.Items) prfs_SaveEntry(EntryHash.Items[e]);
}

function prfs_SaveEntry(entry){
  cqrPrefs.setCharPref("Entries."+entry.eId+".eId", entry.eId);
  cqrPrefs.setCharPref("Entries."+entry.eId+".Title", entry.Title);
  cqrPrefs.setCharPref("Entries."+entry.eId+".Order", entry.order);
  cqrPrefs.setCharPref("Entries."+entry.eId+".filepath", entry.filepath);
  cqrPrefs.setBoolPref("Entries."+entry.eId+".Context", entry.Context);
  cqrPrefs.setBoolPref("Entries."+entry.eId+".blocked", entry.blocked);
}

function prfs_ReadItem(name){
	if (cqrPrefs.prefHasUserValue(name)) {
  	var type = cqrPrefs.getPrefType(name);
    if (type & 128) {
      return cqrPrefs.getBoolPref(name);
    } else if (type & 64) {
      return cqrPrefs.getIntPref(name);
    } else if (type & 32) {
			return cqrPrefs.getCharPref(name);
    }	else {
			return "";
		}
	} else {
	    //Good features must be turned on by default :))
	    if ((name == "Main.HTTPIcon") || (name == "Main.LoadTabsInBg")){
	        return true;
	    } else {
	        return "";
	    }
	}
}

function getPlugIcon(plugpath){
    var icon_gif = plugpath.substr(0, plugpath.length -4) + ".gif";
    var icon_png = plugpath.substr(0, plugpath.length -4) + ".png";
    
    var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    
    file.initWithPath(icon_gif);
    if (file.exists()) {
        return icon_gif;
    } else {
        file.initWithPath(icon_png);
        if (file.exists()) {
            return icon_png;
        } else {
            return "";
        }
    }
}

function exploreobj(obj){
  for (each in obj) {
    show("NODE ::: " + each);
    //a = obj[each];
    //  for (i  in  a){
    //    show(i + " >>> " + a[i]);
    //  }
    }
}

function show(data){
    dump(data + "\n");
}

function cqrAbsURI(base, url) 
{
  var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                .getService(Components.interfaces.nsIIOService);
  var baseURI  = ioService.newURI(base, null, null);
  return ioService.newURI(baseURI.resolve(url), null, null).spec;
}

function cqrGetClipboardText(){
// many thanks to XUL planet! :)
// http://xulplanet.com/tutorials/xultu/clipboard.html
try{
    var clip = Components.classes["@mozilla.org/widget/clipboard;1"].
        getService(Components.interfaces.nsIClipboard);
    if (!clip) return false;

    var trans = Components.classes["@mozilla.org/widget/transferable;1"].
        createInstance(Components.interfaces.nsITransferable);
    if (!trans) return false;
    trans.addDataFlavor("text/unicode");
    clip.getData(trans,clip.kGlobalClipboard);
    var str = new Object();
    var strLength = new Object();

    trans.getTransferData("text/unicode",str,strLength);
    if (str) str = str.value.QueryInterface(Components.interfaces.nsISupportsString);
    if (str) pastetext = str.data.substring(0,strLength.value / 2);
    if (pastetext) return pastetext;
    else return false;
}catch(er){return false;}
}


function cqrGetBrowserForWindow(win) {  
    var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].
        getService(Components.interfaces.nsIWindowMediator);
    var enumerator = windowManager.getEnumerator(null);
    while (enumerator.hasMoreElements()) {
        newBrowser = enumerator.getNext().getBrowser();
        newWin = newBrowser.contentWindow;
        var cntTabs = newBrowser.mTabContainer.childNodes.length;
        for (i=0;i<cntTabs;i++){
            nextTab = newBrowser.mTabContainer.childNodes[i];
            newTabBr = newBrowser.getBrowserForTab(nextTab);
            if (newTabBr.contentWindow == win) return newTabBr; 
        }
    }
    return null;
}

function getFNameFromURI(uri){
    var arr = uri.split("/");
    return arr[arr.length - 1];
    }

function url2host(url){
    var re = new RegExp("^http://([^/]*)","ig");
    retmp = re.exec(url);
    if (retmp) {
        return retmp[0];
    } else {
        return "";
    }
}